<template>
    <div class="customer">
        <button class="ui right floated button positive" v-on:click="open('#addCustomer')">+ Add new customer</button>
        <h1>Customers</h1>

        <table class="ui celled table">
            <thead>
            <tr>
                <th class="id">#</th>
                <th>Firstname</th>
                <th>Lastname</th>
                <th><!-- actions --></th>
            </tr>
            </thead>
            <tbody v-if="customers.length">
            <CustomerListItem
                    v-for="customer in customers"
                    :key="customer.id"
                    :customer="customer"
                    @show="view"
            />
            </tbody>
            <tbody v-else>
            <tr>
                <td colspan="4" class="ui text-center">No customers</td>
            </tr>
            </tbody>

        </table>

        <div class="ui modal" id="addCustomer">
            <i class="close icon"></i>
            <div class="header">
                Add customer
            </div>
            <div class="content">
                <div>
                    <form class="ui form">
                        <div class="field">
                            <label>First Name</label>
                            <input ref="first_name" :value="customer.firstname"/>
                        </div>

                        <div class="field">
                            <label>Last Name</label>
                            <input ref="last_name" :value="customer.lastname"/>
                        </div>
                    </form>
                </div>
            </div>
            <div class="actions">
                <div class="ui gray deny button">
                    Cancel
                </div>
                <div class="ui positive right labeled icon button" @click="save">
                    Save
                    <i class="checkmark icon"></i>
                </div>
            </div>
        </div>

        <div class="ui modal" id="viewCustomer">
            <i class="close icon"></i>
            <div class="header">
                Customer: #<span v-text="selected.id"></span>
            </div>
            <div class="content">
                <form class="ui form">
                    <div class="field">
                        <label>First Name</label>
                        <div>{{selected.firstname}}</div>
                    </div>

                    <div class="field">
                        <label>Last Name</label>
                        <div>{{selected.lastname}}</div>
                    </div>
                </form>
            </div>
            <div class="actions">
                <div class="ui negative button" @click="deleteCustomer(selected.id)">
                    Delete
                </div>
                <div class="ui primary button" @click="close('#viewCustomer')">
                    Close
                </div>
            </div>
        </div>
    </div>

</template>

<script>
    import CustomerListItem from './CustomerListItem.vue'

    export default {
        name: "Customer",
        components: {
            CustomerListItem
        },
        data() {
            return {
                selected: {
                    id: null,
                    firstname: '',
                    lastname: ''
                },
                customer: {
                    firstname: '',
                    lastname: ''
                },
                customers: []
            }
        },
        mounted: function () {
            this.$http.get('./api/customers.json').then((response) => {
                    this.customers = response.body;
                }, function () {
                    alert('No data');
                }
            );
        },
        methods: {
            getAndHandle(url) {
                this.$http.get(url).then((response) => {
                        this.customers = response.body;
                    }, function () {
                        alert('No data');
                    }
                );
            },
            view(id) {
                this.$http.get('./api/customer/read/' + id).then((response) => {
                    this.selected = response.data;

                    jQuery('#viewCustomer').modal('show');
                });
            },
            deleteCustomer(id) {
                if (confirm('Do you want to delete customer?')) {
                    this.$http.post('./api/customer/delete', {id: id}).then((response) => {
                            this.customers = response.body;
                        }, function () {
                            alert('No data');
                        }
                    );
                }
            },
            save() {
                let data = {
                    firstname: this.$refs['first_name'].value,
                    lastname: this.$refs['last_name'].value,
                };
                this.$http.post('./api/customer/create', data).then((response) => {
                        this.customers = response.body;
                    }, function () {
                        alert('No data');
                    }
                );
            },
            open(element) {
                jQuery(element).modal('show');
            },
            close(element) {
                jQuery(element).modal('hide');
            }
        }
    }
</script>

<style scoped>
    .id {
        width: 5%;
    }
</style>